package thyyxxk.webserver.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.Iterator;
import java.util.Map;

/**
 * json工具类
 * @Version 1.0
 */
public final class JsonUtils {

    /**
     * 去除json值前后空格
     * @param jsonStr jsonStr
     * @return
     */
    public static JSONObject jsonTrim(String jsonStr) {
        return jsonTrim(JSONObject.parseObject(jsonStr));
    }

    public static String jsonTrimToString(String jsonStr) {
        return jsonTrim(JSONObject.parseObject(jsonStr)).toJSONString() ;
    }



    /**
     * 去除value的空格
     *
     * @param jsonObject jsonObject
     * @return
     */
    public static JSONObject jsonTrim(JSONObject jsonObject) {
        for (Map.Entry<String, Object> next : jsonObject.entrySet()) {
            Object value = next.getValue();
            if (value != null) {
                if (value instanceof String) {
                    //清空值前后空格
                    jsonObject.put(next.getKey(), ((String) value).trim());
                } else if (value instanceof JSONObject) {
                    jsonTrim((JSONObject) value);
                } else if (value instanceof JSONArray) {
                    jsonTrimArray((JSONArray) value);
                }
            }
        }

        return jsonObject;
    }

    /**
     * 清空JSONArray 值前后空格
     * @param array
     */
    private static void jsonTrimArray(JSONArray array) {
        if (array.size() > 0) {
            for (int i = 0; i < array.size(); i++) {
                Object object = array.get(i);
                if (object != null) {
                    if (object instanceof String) {
                        array.set(i, ((String) object).trim());
                    } else if (object instanceof JSONObject) {
                        jsonTrim((JSONObject) object);
                    } else if (object instanceof JSONArray) {
                        jsonTrimArray((JSONArray) object);
                    }
                }
            }
        }
    }
}
